<?php

namespace App\Controller;

use App\Entity\Counter;
use App\Repository\CounterRepository;
use App\Service\CounterManager;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Attribute\Route;
use Symfony\Component\Serializer\SerializerInterface;

class CounterController extends AbstractController
{
    public function __construct(
        protected CounterManager $counterManager,
    )
    {
        
    }

    #[Route('/counter', name: 'app_counter', methods: ['GET'])]
    public function index(CounterRepository $counterRepository): JsonResponse
    {
        //$counter = $this->counterManager->init("P5M", "Youpi");
        $counters = $counterRepository->findAll();
        return $this->json($counters, 200);
    }

    #[Route('/counter', name: 'app_counter_post', methods: ['POST'])]
    public function postCounter(
        Request $request,
        CounterManager $counterManager,
    ): JsonResponse
    {
        $ttl = $request->toArray()['ttl'] ?? null;
        $name = $request->toArray()['name'] ?? null;

        $counter = $counterManager->init($ttl, $name);

        return $this->json($counter, 200);
    }

    #[Route('/counter/start/{id}', name: 'app_counter_start')]
    public function startCounter(Counter $counter): JsonResponse
    {
        $counter = $this->counterManager->start($counter);

        return $this->json($counter, 200);
    }
}
